var elxwchatgui = null;

if (typeof String.prototype.format == 'undefined') {
    String.prototype.format = function()
    {
       var content = this;
       for (var i=0; i < arguments.length; i++)
       {
            var replacement = '{' + i + '}';
            content = content.replace(replacement, arguments[i]);
       }
       return content;
    };
}

$( document ).ready(function() {
    elxwchatgui = new ElastixSIPPanelGUI('div#elastix-panel-elastixwebphone > div.panel-body');
    elxwchatgui.setupSIPClient();
});


/* La siguiente clase representa el GUI del panel de llamada y chat SIP. */
function ElastixSIPPanelGUI(selector)
{
    // Conexión actual SIP WebRTC
    this._ua = null;

    // Objeto que maneja presencia SIP
    this._sp = null;

    // Sesión de llamada activa
    this._session = null;

    // Subscripción a Message Waiting Indication
    this._mwi = null;

    // Objeto que maneja BLF
    //this._blf = null;

    // Panel dentro del cual se contiene todo lo demás
    this.panel = $(selector);

    // Reproductor de DTMFs
    this._dtmf = new PlayDTMF();

    // Manejadores de eventos instalados globalmente
    this._bind_beforeunload = this.beforeunload.bind(this);
    this._bind_filterlogout = this.filterlogout.bind(this);

    // Clic en el icono de presencia local abre el diálogo de cambio de presencia
    this._panelAS().find('div#presence > a#presenceicon').click(function() {
        var div = this._panelAS().find('div#presence > div#updatepresence');
        if (div.is(':visible')) {
            div.hide();
        } else {
            div.show().focus();
        }
    }.bind(this));

    // Clic fuera de diálogo de cambio de presencia cierra el diálogo
    this._panelAS().find('div#presence > div#updatepresence, div#presence > div#updatepresence *').blur(function(e) {
        var div = this._panelAS().find('div#presence > div#updatepresence');
        var presenceicon = this._panelAS().find('div#presence > a#presenceicon');
        if (presenceicon.get(0) != e.relatedTarget &&
            div.get(0) != e.relatedTarget && !$.contains(div.get(0), e.relatedTarget)) {
            div.hide();
        }
    }.bind(this));

    // Nuevo valor elegido en cambio de presencia colorea el icono a la izquierda
    this._panelAS().find('div#presence > div#updatepresence select#elx_digium_presence_type').change(function() {
        var icon = $(this).prev('i.fa-user');
        var color = 'grey';
        switch ($(this).val()) {
        case 'available': color = '#8cbe29'; break;
        case 'unavailable': color = 'grey'; break;
        case 'away': color = 'yellow'; break;
        case 'xa': color = 'brown'; break;
        case 'chat': color = '#64b5f6'; break;
        case 'dnd': color = 'red'; break;
        }
        icon.css('color', color);
    });

    // Botón de cancelar cambio de presencia cierra el diálogo
    this._panelAS().find('div#presence > div#updatepresence button#elx_digium_presence_cancel').click(function() {
        this._panelAS().find('div#presence > div#updatepresence').hide();
    }.bind(this));

    // Botón de enviar realiza el cambio de presencia y cierra el diálogo
    this._panelAS().find('div#presence > div#updatepresence button#elx_digium_presence_submit').click(function() {
        var div = this._panelAS().find('div#presence > div#updatepresence');
        this._sp.setPresenceStatus(
                div.find('textarea#elx_digium_presence_message').val(),
                [div.find('select#elx_digium_presence_type').val(),div.find('input#elx_digium_presence_subtype').val()]);

        this._panelAS().find('div#presence > div#updatepresence').hide();
    }.bind(this));

    // Clic en icono de volumen muestra el div de controles
    this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > div#icons > a#volumeicon').click(function() {
        var div = this._panelAS().find('div#phonebox > div#volumecontrols');
        if (div.is(':visible')) {
            div.hide();
        } else {
            div.show().focus();
        }
    }.bind(this));

    // Inicialización de slider de volumen
    // Esta inicialización debe hacerse ANTES de instalar el .blur() de cierre
    // de diálogo para que el .blur() se instale correctamente.
    this._panelAS().find('div#phonebox > div#volumecontrols > div#volumeslider')
        .slider({
            min: 0,
            max: 100,
            value:  this._panelAS().find('#elx_media_remote').prop('volume') * 100,
            slide:  this._changeVolume.bind(this),
            change: this._changeVolume.bind(this)
    });

    // Clic fuera del diálogo de volumen cierra el diálogo
    this._panelAS().find('div#phonebox > div#volumecontrols, div#phonebox > div#volumecontrols *').blur(function(e) {
        var div = this._panelAS().find('div#phonebox > div#volumecontrols');
        var volumeicon = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > div#icons > a#volumeicon');
        if (volumeicon.get(0) != e.relatedTarget &&
            div.get(0) != e.relatedTarget && !$.contains(div.get(0), e.relatedTarget)) {
            div.hide();
        }
    }.bind(this));

    // Mute/unmute
    this._panelAS().find('div#phonebox > div#volumecontrols > button#elxwebphone-do-togglemute')
        .click(function() {
        var sess = this.getCurrSession();
        if (sess == null) return;
        if (sess.startTime == null) return;
        var mutestatus = sess.mediaHandler.isMuted();

        if (mutestatus.audio)
            sess.unmute();
        else
            sess.mute();
    }.bind(this));

    // Cambio de pestañas entre los objetivos
    this._panelAS().find('div#bar-buttons > a.barnav').click(function(e) {
        e.preventDefault();
        var a = $(e.currentTarget);
        this._switch2PhoneTabForLink(a);

        if (a.attr('href') == '#elx-phonetab-chats') {
            var unread = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div.chat-unread')
                .first().data('uri');
            if (unread != undefined) {
                this._selectChat(unread, false);
            }
        }
    }.bind(this));

    // Pulsar botón en keypad
    this._panelAS().find('div#elx-phonetab-keypad > div.phonekey').click(function(e) {
        var div = $(e.currentTarget);
        var key = div.data('key');
        var sess = this.getCurrSession();
        if (sess != null) sess.dtmf(key);
        var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
        dialtxt.val(dialtxt.val() + key);
        this._dtmf.play(key);
    }.bind(this));

    // Filtrado de mensajes y activación de contactos offline
    this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_contact_search > input#im_search_filter')
        .keyup(this._updateContactVisibility.bind(this));
    this._panelAS().find('div#elx-phonetab-contacts #elx-chk-show-offline-contacts')
        .click(this._updateContactVisibility.bind(this));

    // Clic en contacto copia la extensión para iniciar una llamada o chat
    this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts')
        .on('click', 'li', function(e) {
        var data = $(e.currentTarget).data();
        var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
        dialtxt.val(data.extension);

        // Cambiar a chat activo si existe
        this._selectChat(data.uri, false);

        // Foco de selección en el input de teléfono
        dialtxt.focus();
    }.bind(this));

    // Clic en icono de marcar para contacto copia la extensión y marca inmediatamente
    this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts')
        .on('click', 'li > i.fa-phone.action', function(e) {

        e.stopPropagation();
        $(e.currentTarget).parent('li').click(); // Copiar teléfono de contacto
        this._panelAS().find('div#bar-buttons > a#elxwebphone-do-call')
            .click().focus();
    }.bind(this));

    // Clic en icono de chat para contacto copia la extensión y abre chat inmediatamente
    this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts')
        .on('click', 'li > i.fa-comment.action', function(e) {

        e.stopPropagation();
        $(e.currentTarget).parent('li').click(); // Copiar teléfono de contacto
        this._panelAS().find('div#bar-buttons > a#elxwebphone-do-chat')
            .click().focus();
    }.bind(this));

    // ENTER en el input de teléfono inicia llamada
    this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension').keydown(function (event) {
        var dial = $(event.currentTarget).val();

        if (event.which == 13) {
            event.preventDefault();
            if (dial != '') {
                this._panelAS().find('div#bar-buttons > a#elxwebphone-do-call').click();

                // Ignore Enter when empty input.
            } else return false;
        } else {
            var k = event.key.toUpperCase();
            if ("0123456789*#ABCD".indexOf(k) != -1) {
                var sess = this.getCurrSession();
                if (sess != null) {
                    sess.dtmf(k);
                    this._dtmf.play(k);
                }
            }
        }
    }.bind(this));

    // Click en indicador de voicemail visible marca buzón de voz
    this._panelAS().find('div#presence > div#mwi').click(function (event) {
        var vmdial = $(event.currentTarget).data('vmdial');
        var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
        dialtxt.val(vmdial);
        this._panelAS().find('div#bar-buttons > a#elxwebphone-do-call').click();
    }.bind(this));

    // Marcar llamada
    this._panelAS().find('div#bar-buttons > a#elxwebphone-do-call')
        .click(function() {
        var ua = this._getCurrSIPUA();
        var sess = this.getCurrSession();
        if (sess != null) return;   // Esto no debería pasar

        var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
        var dialstring = dialtxt.val();
        dialtxt.val('');

        // Construir cadena de marcado completa con dominio
        dialstring = dialstring.trim();
        if (dialstring == '') return;
        if (dialstring.indexOf('@') == -1) {
            dialstring += '@' + ua.configuration.hostportParams;
        }

        sess = ua.invite(dialstring, this._getVideoCallMedia());
        if (sess.data == undefined) sess.data = {};
        sess.data.outgoing = true;
        this.setCurrSession(sess);

        this.displayPhoneCalling();
        this.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_DIALING + ': ' + dialstring);
        this._dtmf.ring(true);
    }.bind(this));

    // Iniciar chat
    this._panelAS().find('div#bar-buttons > a#elxwebphone-do-chat')
        .click(function() {
        var ua = this._getCurrSIPUA();

        var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
        var dialstring = dialtxt.val();

        // Construir cadena de marcado completa con dominio
        dialstring = dialstring.trim();
        if (dialstring == '') return;
        if (dialstring.indexOf('@') == -1) {
            dialstring += '@' + ua.configuration.hostportParams;
        }

        // Si no se ha especificado schema, buscar en roster
        if (/^\w+:/.exec(dialstring) == null) {
            var chatgroup = this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts');
            var liContact = chatgroup.children('li[data-uri="sip:'+dialstring+'"]');
            if (liContact.length <= 0)
                liContact = chatgroup.children('li[data-uri$=":'+dialstring+'"]');
            if (liContact.length > 0)
                dialstring = liContact.first().data('uri');
            else dialstring = 'sip:'+dialString;
        }

        this._selectChat(dialstring, true);
        this._panelAS().find('div#elx-phonetab-chats > textarea').focus();
    }.bind(this));

    // Seleccionar chat activo a través del select
    this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active')
        .change(function() {
        var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');
        var uri = sel.val();
        var mainchat_ctl = 'div#elx-phonetab-chats > textarea, div#elx-phonetab-chats > span#elx_close_chat, div#elx-phonetab-chats > div#elx_chat_group';

        this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div').hide();
        this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div[data-uri="' + uri + '"]').show();
        if (uri == '') {
            this._panelAS().find(mainchat_ctl).hide();
        } else {
            this._panelAS().find(mainchat_ctl).show();
        }

        var chatdiv = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div:visible');
        chatdiv.removeClass('chat-unread');
        this._countUnreadChats();
        this._clearNotifyChatMsg();
    }.bind(this));

    // Eliminar el chat seleccionado en el select
    this._panelAS().find('div#elx-phonetab-chats > span#elx_close_chat').click(function() {
        var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');

        this._closeChat(sel.val());
    }.bind(this));

    // Enviar mensaje de chat
    this._panelAS().find('div#elx-phonetab-chats > textarea').on('keydown', function(event) {
        var msg = $(event.currentTarget).val();

        // Ignore TAB and ESC.
        if (event.which == 9 || event.which == 27) {
            return false;
            // Enter pressed? so send chat.
        } else if (event.which == 13) {
            event.preventDefault();
            if (msg != '') {
                $(event.currentTarget).val('');
                var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');
                this._sendMessage(msg, sel.val());

                // Ignore Enter when empty input.
            } else return false;
        }
    }.bind(this));

    // Clic en historial toma el número del span y lo pone como listo para marcar
    this._panelAS().find('div#elx-phonetab-callhistory > ul#elx_ul_list_calls')
        .on('click', 'li', function(e) {
        var extension = $(e.currentTarget).data('phone').toString();
        if (/^[\d#*]+$/.exec(extension)) {
            var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
            dialtxt.val(extension);

            // Foco de selección en el input de teléfono
            dialtxt.focus();
        }
    }.bind(this))
        .on('dblclick', 'li', function(e) {
        // Doble clic inicia el marcado de inmediato
        var extension = $(e.currentTarget).data('phone').toString();
        if (/^[\d#*]+$/.exec(extension)) {
            var dialtxt = this._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension');
            dialtxt.val(extension);

            // Foco de selección en el input de teléfono
            dialtxt.focus();

            // Marcar llamada
            this._panelAS().find('div#bar-buttons > a#elxwebphone-do-call').click();
        }
    }.bind(this));

    // Contestar llamada
    this._panelAS().find('div#bar-buttons > a#elxwebphone-do-answer')
        .click(function() {
        this._dtmf.ring(false);
        var sess = this.getCurrSession();
        if (sess != null) sess.accept(this._getVideoCallMedia());
    }.bind(this));

    // Rechazar llamada
    this._panelAS().find('div#bar-buttons > a#elxwebphone-do-reject')
        .click(function() {
        this._dtmf.ring(false);
        var sess = this.getCurrSession();
        if (sess != null) sess.reject();
    }.bind(this));

    // Colgar/cancelar llamada
    this._panelAS().find('div#bar-buttons > a#elxwebphone-do-hangup')
        .click(function() {
        this._dtmf.ring(false);
        var sess = this.getCurrSession();
        if (sess != null) {
            if (sess.startTime != null)
                sess.bye();
            else
                sess.cancel();
        }
    }.bind(this));

    // Hold
    this._panelAS().find('div#bar-buttons > a#elxwebphone-do-togglehold')
        .click(function() {
        var sess = this.getCurrSession();
        if (sess == null) return;
        if (sess.startTime == null) return;

        var holdstatus = sess.isOnHold();
        if (holdstatus.local) {
            // Llamada está en hold local
            sess.unhold();
        } else {
            // Llamada será puesta en hold
            sess.hold();
        }
    }.bind(this));


    // Verificar soporte de notificaciones para llamadas entrantes
    this._canNotify = false;
    this._notiCall = null;
    this._notiChat = null;
    this._oldUnreadCount = 0;
    if ('Notification' in window) {
        if (Notification.permission === 'granted') {
            this._canNotify = true;
        } else if (Notification.permission !== 'denied') {
            Notification.requestPermission(function (perm) {
                if (perm === 'granted') this._canNotify = true;
            }.bind(this));
        }
    }
}
/**
 * Procedimiento que inicia la configuración de las configuraciones SIP. Las
 * dependencias que hay que resolver hasta ahora son las siguientes:
 *
 * Carga credenciales SIP,
 *  requiere: (nada)
 * Inicio cliente SIP
 *  requiere: Carga credenciales SIP
 * Carga lista de contactos
 *  requiere: (nada)
 * Creación de lista de contactos con data
 *  requiere: Carga lista de contactos
 * Publicación de presencia propia
 *  requiere: Inicio cliente SIP
 * Subscripción a lista de contactos
 *  requiere: Inicio cliente SIP, Creación de lista de contactos con data
 *
 * @return void
 */
ElastixSIPPanelGUI.prototype.setupSIPClient = function ()
{
    this.displaySessionLoading();

    var deferred_registerUA = new $.Deferred();
    var deferred_rosterLoad = new $.Deferred();

    // Iniciar la carga de las credenciales SIP
    $.get('index.php', {
        menu: '_elastixutils',
        action: 'extension_current_user'
    }, function (response) {
        if (response.error != '') {
            // Rechazar la promesa con el mensaje de error
            deferred_registerUA.reject(response.error);
        } else if (response.message.tech != 'sip') {
            // Tecnología no es SIP
            deferred_registerUA.reject(arrLang_panel.elastixwebphone.MSG_INCOMPATIBLE_VOIP_TECH);
        } else {
            var arrData = response.message;

            // Con las credenciales, se puede iniciar el SIP.UA
            var ip_pbx = window.location.host;
            var ua_params = {
                //log:                {level: "debug"},
                log:                {level: 1},
                //traceSip:           true,
                userAgentString:    'a SIP.js that knows how to parse Digium presence',
                uri:                arrData.authorizationUser + '@' + ip_pbx,
                wsServers:          'wss://' + ip_pbx + '/asterisk/ws',
                authorizationUser:  arrData.authorizationUser,
                password:           arrData.password,
                rel100:             SIP.C.supported.SUPPORTED,
                hackIpInContact:    true,
                hackWssInTransport: true,
                autostart:          true
                //register:           response.message.register,
                //registerExpires:    response.message.register_expires,
                //usePreloadedRoute:  response.message.use_preloaded_route,
                //noAnswerTimeout:    response.message.no_answer_timeout,
                //stunServers:        ["stun:null"],
            };
            this._panelAS().find('div#presence > span#username').text(ua_params.uri);
            if (arrData.displayName != undefined) {
                ua_params.displayName = arrData.displayName;
                this._panelAS().find('div#presence > span#username').text(ua_params.displayName);
            }
            this._ua = new SIP.UA(ua_params);
            this._ua.on('message', function (e) {
                var remoteUri = e.remoteIdentity.uri.toString();
                if (e.remoteIdentity.uri.user == 'elxrouting' &&
                    e.request.headers['X-Elastixrouting-Uri'] != undefined)
                    remoteUri = e.request.headers['X-Elastixrouting-Uri'][0].raw;

                var displayName = e.remoteIdentity.displayName;
                if (displayName == null || displayName == 'Unknown')
                    displayName = undefined;

                this.receiveMessage(remoteUri, displayName, e.contentType, e.body);
            }.bind(this)).on('disconnected', function() {
                this.displayStatusError(arrLang_panel.elastixwebphone.MSG_DISCONNECTED);
            }.bind(this)).on('registered', function () {
                // El registro exitoso es uno de los requisitos para iniciar suscripción
                this.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_READY_DIAL);
                deferred_registerUA.resolve();
            }.bind(this)).on('registrationFailed', function(cause) {
                deferred_registerUA.reject(arrLang_panel.elastixwebphone.MSG_REGISTRATION_FAILED + ': ' + cause);
            }.bind(this)).on('invite', function (incoming_session) {
                // Rechazar llamada si hay otra activa.
                if (this.getCurrSession() != null) {
                    incoming_session.reject({
                        statusCode:     486 // Busy here
                    });
                    return;
                }

                // Si el estado es DND, rechazar con "Do Not Disturb"
                if (this._sp.presentity.activities.indexOf('dnd') == 0) {
                    incoming_session.reject({
                        statusCode:     486,
                        reasonPhrase:   'Do Not Disturb'
                    });
                    return;
                }

                if (incoming_session.data == undefined) incoming_session.data = {};
                incoming_session.data.outgoing = false;
                this.setCurrSession(incoming_session);
                this.displayPhoneIncoming(
                    incoming_session.remoteIdentity.uri.user,
                    incoming_session.remoteIdentity.displayName);
            }.bind(this));

            $('body').on('click', 'a', this._bind_filterlogout);
            $(window).on('beforeunload', this._bind_beforeunload);
        }
    }.bind(this)).fail(function() {
        deferred_registerUA.reject(arrLang_panel.elastixwebphone.MSG_SIP_PARAM_FAILED);
    }.bind(this));

    // Iniciar la carga de la lista de contactos
    $.getJSON( "rest.php/address_book/ContactList/internal", function(data) {
        this.clearContactRoster();
        $.each( data.extension, function(key, val) {
            // Se asume que todo el roster es alcanzable vía SIP
            var uri = 'sip:' + val.user + '@' + window.location.host;
            this.addContact2Roster(val.id, val.name, uri, uri, val.phone, val);
        }.bind(this));
        deferred_rosterLoad.resolve();
    }.bind(this)).fail(function() {
        /* Lidiar con escenario en el cual la agenda está denegada al usuario
         * actual. */
        //deferred_rosterLoad.reject(arrLang_panel.elastixwebphone.MSG_SIP_ROSTER_FAILED);
        this.clearContactRoster();
        this.displaySessionError(arrLang_panel.elastixwebphone.MSG_SIP_ROSTER_FAILED);
        deferred_rosterLoad.resolve();
    }.bind(this));

    // Iniciar la subscripción cuando todas las promesas puedan resolverse
    $.when(deferred_registerUA, deferred_rosterLoad)
    .done(function() {
        this.displaySessionActive();

        this.subscribeAll();

        this._restoreSessionStorage_Chat();
        if (window.sessionStorage != undefined) {
            if (window.sessionStorage.elxWebphoneActiveCallID != undefined) {
                var sid = window.sessionStorage.elxWebphoneActiveCallID;
                var dialstring = window.sessionStorage.elxWebphoneActiveCallUser;
                delete window.sessionStorage.elxWebphoneActiveCallID;
                delete window.sessionStorage.elxWebphoneActiveCallUser;

                var options = this._getVideoCallMedia();
                if (options.extraHeaders == undefined) options.extraHeaders = [];
                options.extraHeaders.push('Replaces: ' + sid);
                var sess = this._ua.invite(dialstring, options);
                if (sess.data == undefined) sess.data = {};
                sess.data.outgoing = true;
                this.setCurrSession(sess);

                this.displayPhoneCalling();
                this.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_DIALING + ': ' + dialstring);
                this._dtmf.ring(true);

                if (!this.panel.is(':visible')) {
                    // HACK esto debería ser rutina oficial del framework
                    // Mostrar la barra lateral si estaba oculta
                    $('#togglesidebar').click();
                }
            }
        }
    }.bind(this)).fail(function(msg) {
        this.displaySessionError(msg);
    }.bind(this));
}
ElastixSIPPanelGUI.prototype.subscribeAll = function() {
    this.subscribeMWI();
    if (this._sp == null) this._sp = new SIPPresence(this._ua, this);
    //if (this._blf == null) this._blf = new SIPBLF(this._ua, this);
}
ElastixSIPPanelGUI.prototype.unsubscribeAll = function() {
/*
    if (this._blf != null) {
        this._blf.unsubscribeAll();
        this._blf = null;
    }
*/
    if (this._sp != null) {
        this._sp.unsubscribeAll();
        this._sp = null;
    }
    this.unsubscribeMWI();
}
ElastixSIPPanelGUI.prototype.shutdownSIPClient = function() {
    this.unsubscribeAll();

    $('body').off('click', 'a', this._bind_filterlogout);
    $(window).off('beforeunload', this._bind_beforeunload);

    this._ua.unregister();
    this._ua.stop();
    this._ua = null;

    this.displaySessionLoading();
}
ElastixSIPPanelGUI.prototype.filterlogout = function(event) {
    var a = event.currentTarget;
    if (window.sessionStorage == undefined) return;
    delete window.sessionStorage.elxWebphoneLoggingOut;
    var href = $(a).attr('href');
    if (href.includes('?logout=yes'))
        window.sessionStorage.elxWebphoneLoggingOut = "logout";
}
ElastixSIPPanelGUI.prototype.beforeunload = function() {
    if (window.sessionStorage != undefined) {
        if (window.sessionStorage.elxWebphoneLoggingOut == undefined) {
            if (this._session != null) {
                /* Hay una llamada activa al momento de ir a otra página. */
                var sid = this._session.request.call_id;
                var fromtag; var totag;
                if (this._session.data.outgoing) {
                    fromtag = this._session.request.from.parameters.tag;
                    totag = this._session.to_tag;
                } else {
                    // NOTA: tag de asterisk debe siempre mandarse como to-tag
                    fromtag = this._session.request.to_tag;
                    totag = this._session.request.from_tag;
                }

                if (fromtag != undefined && totag != undefined) {
                    // Quitar de SIP.js la llamada activa para que no la cierre
                    for (session in this._ua.sessions) {
                        if (this._ua.sessions[session].request.call_id == sid)
                            delete this._ua.sessions[session];
                    }

                    sid += ';to-tag=' + totag;
                    sid += ';from-tag=' + fromtag;
                    window.sessionStorage.elxWebphoneActiveCallID = sid;
                    window.sessionStorage.elxWebphoneActiveCallUser =
                        this._session.remoteIdentity.uri.user;
                }
            }
        } else {
            delete window.sessionStorage.elxWebphoneLoggingOut;
        }
    }

    // Run  _terminate_ on every Session
    for(session in this._ua.sessions) {
        this._ua.logger.log('closing session ' + session);
        this._ua.sessions[session].terminate();
    }

    //Run _close_ on every Subscription
    for(subscription in this._ua.subscriptions) {
        this._ua.logger.log('unsubscribing from subscription ' + subscription);
        this._ua.subscriptions[subscription].close();
    }

    this._ua.stop();
}
ElastixSIPPanelGUI.prototype._getCurrSIPUA = function() {
    return this._ua;
}
ElastixSIPPanelGUI.prototype.getCurrSession = function() {
    return this._session;
}
ElastixSIPPanelGUI.prototype.displaySessionLoading = function() {
    // Marcar color de presencia como desconectado hasta actualizar
    this.updateMyStatus('gray');
    this.panel.find('div.elxwebphone-loadstage').hide();
    this.panel.find('div#elxwebphone-starting-session').show();
}
ElastixSIPPanelGUI.prototype.displaySessionActive = function() {
    this.panel.find('div.elxwebphone-loadstage').hide();
    this.panel.find('div#elxwebphone-active-session').show();

    this._updateContactVisibility();
}
ElastixSIPPanelGUI.prototype.displaySessionError = function(msg) {
    this.panel.find('div.elxwebphone-loadstage').hide();
    this.panel.find('div#elxwebphone-error-session > span').text(msg);
    this.panel.find('div#elxwebphone-error-session').show();
}
ElastixSIPPanelGUI.prototype._panelAS = function() {
    return this.panel.children('div#elxwebphone-active-session');
}
ElastixSIPPanelGUI.prototype.displayStatusMessage = function (statustxt) {
    this._panelAS().find('div#phonebox > div#dial-statustext')
        .removeClass('error')
        .text(statustxt);
}
ElastixSIPPanelGUI.prototype.displayStatusError = function (statustxt) {
    this._panelAS().find('div#phonebox > div#dial-statustext')
        .addClass('error')
        .text(statustxt);
}
ElastixSIPPanelGUI.prototype.clearContactRoster = function() {
    this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts')
        .empty();
}
ElastixSIPPanelGUI.prototype.addContact2Roster = function(idUser, display_name, uri, alias,
    extension, extradata) {
    var listcontacts = this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts');
    var liContact = listcontacts.find('ul#elx_template_contact_status > li').clone()
        .attr('data-status', 'offline')
        .attr('data-uri', uri)
        .attr('data-alias', alias)
        .attr('data-name', display_name)
        .attr('data-idUser', idUser)
        .attr('data-extension', extension);
    liContact.find('div.elx_contact_div').text(display_name);
    this._updateContactTag(liContact, 'grey', '(unknown)');
    listcontacts.children('ul#elx_ul_list_contacts').append(liContact);

    this._panelAS().find('div#elx-phonetab-callhistory > ul#elx_ul_list_calls > li[data-phone="'+extension+'"] > div.phone > span.contactname')
        .text(display_name);
}
ElastixSIPPanelGUI.prototype.updateContactStatus = function(contact, newColor, newNote) {
    var liContact = this._panelAS().find(
        "div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li[data-uri='" + contact + "']");
    if (contact == this.getLocalContact()) {
        liContact.addClass('local');
        this._panelAS().find('div#presence > span#username').text(liContact.data('name'));
        this.updateMyStatus(newColor, newNote);
    }
    this._updateContactTag(liContact, newColor, newNote);
    this._updateContactVisibility();
}
ElastixSIPPanelGUI.prototype._updateContactTag = function (liContact, newColor, newNote) {
    liContact.data('status', (newColor != 'grey') ? 'online' : 'offline');
    liContact.find('i.fa-user.status').css('color', newColor);
    liContact.attr('title', newNote);
}
ElastixSIPPanelGUI.prototype.updateMyStatus = function(newColor, newNote) {
    this._panelAS().find('div#presence > a#presenceicon')
        .css('color', newColor)
        .attr('title', newNote);
}
ElastixSIPPanelGUI.prototype.updateDigiumPresence = function(type, subtype, message) {
    this._panelAS().find('div#presence > div#updatepresence select#elx_digium_presence_type')
        .val(type)
        .change();
    this._panelAS().find('div#presence > div#updatepresence input#elx_digium_presence_subtype')
        .val(subtype);
    this._panelAS().find('div#presence > div#updatepresence textarea#elx_digium_presence_message')
        .val(message);
}
ElastixSIPPanelGUI.prototype.updateContactBLF = function(contact, status) {
    var liContact = this._panelAS().find(
        "div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li[data-uri='" + contact + "']");

    liContact.children('i.fa-phone.status')
        .removeClass('ringing')
        .removeClass('oncall');
    if (status == 'ringing' || status == 'oncall')
        liContact.children('i.fa-phone.status').addClass(status);
}
/**
 * Esta función actualiza el estado de visibilidad de todos los contactos. Un
 * contacto debe mostrarse si su nombre coincide con el patrón de búsqueda (una
 * cadena vacía coincide con todo), y si deben mostrarse los contactos offline,
 * o si el contacto en sí está online.
 */
ElastixSIPPanelGUI.prototype._updateContactVisibility = function(e) {
    var im_search_filter = this.panel.find("input#im_search_filter");
    if (e != undefined) {
        // Si se tiene evento keyup con ESC, se borra la búsqueda
        if (e.keyCode != undefined && e.keyCode == 27) {
            im_search_filter.val('');
        }
    }

    var substr = im_search_filter.val().toLowerCase();
    var mostrarTodos = this.panel.find('#elx-chk-show-offline-contacts').is(':checked');

    // Ocultar todos los contactos, y volver a mostrar sólo coincidencias
    this._panelAS().find("div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li")
    .hide()
    .each(function() {
        var mostrable = (mostrarTodos || $(this).data('status') != 'offline');
        var n = $(this).data('name');
        n = n.toString().toLowerCase();   // Obligar a que sea cadena, no número
        if (n.indexOf(substr) != -1 && mostrable) {
            $(this).show();
        }

        // Mostrar también si subcadena de extensión
        var ext = $(this).data('extension');
        if (ext != undefined) {
            ext = ext.toString().toLowerCase();
            if (ext.indexOf(substr) != -1 && mostrable) {
                $(this).show();
            }
        }
    });

    // Buscar en fuentes externas si subcadena mayor al límite
    if (substr.length >= 2) {
        $.getJSON('rest.php/elastix_ldapsearch/search', {q : substr}, function(data) {
            // TODO: sort
            var listcontacts = this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts');
            var ul = listcontacts.find("ul#elx_ul_list_contacts");
            ul.find('li.external').remove();

            for (var i = 0; i < data.extension.length; i++) {
                // Sólo mostrar un contacto si hay teléfonos
                var phones = [];
                for (var k in data.extension[i].phones)
                    phones = phones.concat(data.extension[i].phones[k]);
                if (phones.length > 0) {
                    var display_name = data.extension[i].attr.name;
                    if (data.extension[i].attr.last_name != undefined)
                        display_name += ' ' + data.extension[i].attr.last_name;
                    for (var j = 0; j < phones.length; j++) {
                        var extension = phones[j][0];
                        //var uri = extension;
                        //var alias = uri;
                        var liContact = listcontacts.find('ul#elx_template_contact_status > li').clone()
                            .attr('data-status', 'offline')
                            //.attr('data-uri', uri)
                            //.attr('data-alias', alias)
                            .attr('data-name', display_name)
                            .attr('data-extension', extension)
                            .attr('title', 'LDAP: ' + extension);
                        liContact.find('div.elx_contact_div').text(display_name);
                        liContact.addClass('external');
                        liContact.find('i.fa-phone.status, i.fa-comment.action')
                            .remove();
                        liContact.find('i.fa-user.status')
                            .removeClass('fa-user')
                            .addClass('fa-globe');
                        listcontacts.children('ul#elx_ul_list_contacts').append(liContact);
                    }
                }
            }
        }.bind(this));
    } else {
        this._panelAS()
            .find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li.external')
            .remove();
    }
}
ElastixSIPPanelGUI.prototype.getContactURIs = function() {
    return this._panelAS().find("div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li")
        .map(function (i, e) { return $(e).data('uri'); })
        .get();
}
ElastixSIPPanelGUI.prototype.displayPhoneIdle = function() {
    this._dtmf.ring(false);
    if (this._notiCall != null) { this._notiCall.close(); this._notiCall = null; }

    // Mostrar botones que corresponden al estado ocioso
    this._panelAS().find('div#bar-buttons')
        .removeClass('onring calling oncall hold')
        .addClass('onidle');
    this._panelAS().find('#elx_media_remote, div#elxwebphone-active-session > #elx_media_local')
        .hide();
    this._showMuted(false);

    this._panelAS().find('div#phonebox > div#volumecontrols > button#elxwebphone-do-togglemute')
        .prop('disabled', true);
}
ElastixSIPPanelGUI.prototype.displayPhoneIncoming = function(dialstring, displayname) {
    // Mostrar botones que corresponden a llamada entrante que timbra
    this._panelAS().find('div#bar-buttons')
        .removeClass('calling oncall onidle hold')
        .addClass('onring');
    this._showMuted(false);

    var s_inc = arrLang_panel.elastixwebphone.MSG_INCOMING_CALL.format(displayname, dialstring)
        + ' (' + arrLang_panel.elastixwebphone.MSG_CLICK_TO_ANSWER + ')';
    this.displayStatusMessage(s_inc);
    this._dtmf.ring(true);
    if (this._canNotify) {
        if (this._notiCall != null) this._notiCall.close();
        this._notiCall = new Notification(arrLang_panel.elastixwebphone.TITLE_NOTI_INCOMING_CALL, {
            // Firefox no muestra la notificación si se indica un icono
            /*icon:   'images/call.png',*/
            body:   s_inc
        });

        this._notiCall.onclick = function() {
            if (!this.panel.is(':visible')) {
                // HACK esto debería ser rutina oficial del framework
                // Mostrar la barra lateral si estaba oculta
                $('#togglesidebar').click();
            }
            this._panelAS().find('div#bar-buttons > a#elxwebphone-do-answer')
                .click();
        }.bind(this);
    }

    this._panelAS().find('div#phonebox > div#volumecontrols > button#elxwebphone-do-togglemute')
        .prop('disabled', true);
}
ElastixSIPPanelGUI.prototype.displayPhoneCalling = function() {
    this._dtmf.ring(true);
    if (this._notiCall != null) { this._notiCall.close(); this._notiCall = null; }

    // Mostrar botones que corresponden a intento de marcado
    this._panelAS().find('div#bar-buttons')
        .removeClass('oncall onring onidle hold')
        .addClass('calling');
    this._showMuted(false);

    this._panelAS().find('div#phonebox > div#volumecontrols > button#elxwebphone-do-togglemute')
        .prop('disabled', true);
}
ElastixSIPPanelGUI.prototype.displayPhoneOnCall = function() {
    this._dtmf.ring(false);
    if (this._notiCall != null) { this._notiCall.close(); this._notiCall = null; }

    // Mostrar botones que corresponden a llamada activa
    this._panelAS().find('div#bar-buttons')
        .removeClass('calling onring onidle hold')
        .addClass('oncall');
    this._showMuted(false);
    // Desactivar video hasta hacer pruebas sobre ubicación de tag <video> en página

    this._panelAS().find('div#phonebox > div#volumecontrols > button#elxwebphone-do-togglemute')
        .prop('disabled', false);

    var showvideo = false;
    var sess = this.getCurrSession();
    var ms = sess.getRemoteStreams();
    if (ms.length > 0) {
        var vt = ms[0].getVideoTracks();
        if (vt.length > 0) showvideo = true;
    }

    if (showvideo) {
        this._panelAS().find('video#elx_media_remote, div#elxwebphone-active-session > video#elx_media_local')
            .show();
    }
}
ElastixSIPPanelGUI.prototype._switch2PhoneTabForLink = function(a) {
    var href = a.attr('href');

    a.parent('div#bar-buttons').children('a.barnav').removeClass('selected');
    a.addClass('selected');
    this._panelAS().find('div.phonetab').hide();
    this._panelAS().find('div.phonetab'+href).show();

    // Si uno de los chats no leídos se vuelve visible, se actualiza cuenta
    var chatdiv = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div:visible');
    chatdiv.removeClass('chat-unread');
    this._countUnreadChats();
    this._clearNotifyChatMsg();
}
ElastixSIPPanelGUI.prototype._getVideoCallMedia = function() {
    return {
        media: {
            constraints: {
                audio: true,
                video: false // <-- desactivado video mientras se investiga fallo de videollamada
            },
            render: {
                remote: this._panelAS().find('#elx_media_remote').get(0),
                local: this._panelAS().find('#elx_media_local').get(0)
            }
        }
    };
}
ElastixSIPPanelGUI.prototype.setCurrSession = function(sess) {
    this._session = sess;
    if (sess == null) return;

    sess.data.gui = this;
    sess.data.finalmsg = false;

    sess.on('progress', function(response) {
        this.data.gui.displayStatusMessage(response.status_code + ' ' + response.reason_phrase);//alert-info

        // Aceptar 183 con SDP de Asterisk sin 100rel
        // https://github.com/onsip/SIP.js/issues/211
        // https://github.com/onsip/SIP.js/issues/242
        if (response.status_code === 183 && response.body && this.hasOffer && !this.dialog) {
            if (!response.hasHeader('require') || response.getHeader('require').indexOf('100rel') === -1) {
                this.mediaHandler.setDescription(response.body)
                .then(function onSuccess () {
                    this.data.gui._dtmf.ring(false);
                    this.status = SIP.Session.C.STATUS_EARLY_MEDIA;
                    this.mute();
                }.bind(this), function onFailure (e) {
                    this.logger.warn(e);
                    this.acceptAndTerminate(response, 488, 'Not Acceptable Here');
                    this.failed(response, SIP.C.causes.BAD_MEDIA_DESCRIPTION);
                }.bind(this));
            }
        }
    }).on('cancel', function() {
        this.data.gui.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_CALL_CANCELLED);//alert-success
        this.data.finalmsg = true;
        this.data.gui.setCurrSession(null);
        this.data.gui.displayPhoneIdle();
    }).on('accepted', function(data) {
        if (this.to_tag == undefined) this.to_tag = data.to_tag;
        if (this.from_tag == undefined) this.from_tag = data.from_tag;

        var user = this.remoteIdentity.uri.user;
        this.data.gui.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_CALL_ACCEPTED);//alert-success
        this.data.gui.displayPhoneOnCall();
        this.data.gui._addPhone2History(user, this.data.outgoing ? 'successful' : 'answered');
        this.data.gui._panelAS().find('div#phonebox > div#elxwebphone-dialed-extension-wrap > input#elxwebphone-dialed-extension').focus();
    }).on('failed', function(response, cause) {
        if (!this.data.finalmsg) {
            var msg = cause +
                ((response != null && (typeof response != 'string'))
                    ? (': ' + response.status_code + ' ' + response.reason_phrase)
                    : '');
            this.data.gui.displayStatusError(msg);//alert-danger
            this.data.finalmsg = true;
        }
        var user = this.remoteIdentity.uri.user;
        this.data.gui._addPhone2History(user, this.data.outgoing ? 'failed' : 'missed');

        // NO se anula la sesión aquí sino en evento terminated
    }).on('bye', function(request) {
        this.data.gui.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_CALL_TERMINATED);//alert-info
        this.data.finalmsg = true;

        // NO se anula la sesión aquí sino en evento terminated
    }).on('terminated', function(message, cause) {
        if (!this.data.finalmsg) {
            this.data.gui.displayStatusMessage(arrLang_panel.elastixwebphone.MSG_CALL_TERMINATED);//alert-info
            this.data.finalmsg = true;
        }
        this.data.gui.setCurrSession(null);
        this.data.gui.displayPhoneIdle();
    }).on('muted', function(data) {
        if (data.audio || data.video) {
            this.data.gui._showMuted(true);
        }
    }).on('unmuted', function(data) {
        if (data.audio || data.video) {
            this.data.gui._showMuted(false);
        }
    }).on('hold', function(data) {
        if (data.originator == 'local') {
            this.data.gui._panelAS().find('div#bar-buttons').addClass('hold');
        }
        if (data.originator == 'remote') {
            // El otro lado nos puso en hold. ¿Qué hay que hacer aquí?
        }
    }).on('unhold', function(data) {
        if (data.originator == 'local') {
            this.data.gui._panelAS().find('div#bar-buttons').removeClass('hold');
        }
        if (data.originator == 'remote') {
            // El otro lado nos puso en hold. ¿Qué hay que hacer aquí?
        }
    });
}
ElastixSIPPanelGUI.prototype._selectChat = function(uri, create) {
    var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');

    // Buscar si existe el chat activo para el uri indicado
    var op = sel.children('option[value="' + uri + '"]');
    if (op.length <= 0) {
        if (!create) return;

        this._createChat(uri);
    } else {
        op.removeClass('chat-closed').show();
        sel.children('option[value=""]').hide();
    }

    // Simular que se elige el tab de chat
    this._switch2PhoneTabForLink(this._panelAS().find('div#bar-buttons > a#barnav-chats'));

    // Seleccionar el select
    sel.val(uri);
    sel.change();

    this._updateSessionStorage_Chat();
}
ElastixSIPPanelGUI.prototype._createChat = function(uri, displayName) {
    var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');
    var chatgroup = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group');

    // Buscar nombre descriptivo en la lista de contactos
    var chatLabel = uri;
    if (displayName != undefined) chatLabel = displayName;
    var liContact = this._panelAS().find("div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li[data-uri=\"" + uri + "\"]");
    if (liContact.length > 0) chatLabel = liContact.data('name');

    // Crear el item de select y el div
    $('<option />')
        .val(uri)
        .text(chatLabel)
        .appendTo(sel);
    $('<div style="display: none;"/>')
        .attr('data-uri', uri)
        .attr('data-name', chatLabel)
        .appendTo(chatgroup);
    sel.children('option[value=""]').hide();
    sel.prop('disabled', false);

    // Si el valor previo era el de no-chat, mostrar el recién agregado
    if (sel.val() == '') {
        sel.val(uri);
        sel.change();
    }
}
ElastixSIPPanelGUI.prototype._sendMessage = function (msg_txt, uri) {
    /* Asterisk 11.21.0 tiene un bug en el que si un texto de mensaje empieza
     * con espacios, el cuerpo del mensaje entero se queda vacío. Hasta parchar
     * Asterisk para corregir esto, se quitan los espacios en blanco al inicio.
     */
    msg_txt = msg_txt.trimLeft();

    var routinguri = uri;
    var options = {};
    if (!routinguri.startsWith('sip:')) {
        routinguri = 'sip:elxrouting';
        options.extraHeaders = ['X-ElastixRouting-URI: '+uri];
    }

    var ua = this._getCurrSIPUA();
    this._addMessage(uri, 'out', msg_txt);

    ua.message(routinguri, msg_txt, options).on('failed', function (response, cause) {
        var error_msg = (response)
            ? response.status_code.toString() + " " + response.reason_phrase
            : cause;

        var target = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div[data-uri="' + uri + '"]');
        target.find("div").last().css("color","red");
        this._addMessage(uri, 'in', $('<span style="color: red;"></span>').text(error_msg));
    }.bind(this));
}
ElastixSIPPanelGUI.prototype.receiveMessage = function(urioralias, displayName, content_type, msg_txt) {
    /* En Elastix 2 y 4, el valor de urioralias puede tener un dominio con una
     * IP, ya que se puede recibir el mensaje desde un endpoint conectado en
     * una interfaz distinta. Se separa el valor de extensión y se busca en el
     * roster SIP para normalizar, antes de buscar entre los chats activos.  */
    var m = /^(\w+:)?(\S+)@(\S+)$/.exec(urioralias);
    var schema = m[1];
    var user = m[2];
    var domain = m[3];
    if (schema == undefined) schema = 'sip:';
    var liContact = this._panelAS().find(
        'div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li[data-uri^="'+schema+user+'@"]');
    if (liContact.length > 0) {
        urioralias = liContact.data('uri');
    }

    var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');
    // Buscar si existe el chat activo para el uri indicado
    var op = sel.children('option[value="' + urioralias + '"]');
    if (op.length <= 0) {
        this._createChat(urioralias, displayName);
    } else {
        op.removeClass('chat-closed').show();
        sel.children('option[value=""]').hide();
    }

    if (content_type == 'application/im-iscomposing+xml') {
        var xml = $.parseXML(msg_txt);
        var state = $(xml).find('isComposing > state').text();
        if (state != 'active') state = 'idle';

        this._setComposingState(urioralias, state);
    } else {
        this._addMessage(urioralias, 'in', msg_txt);
    }
}
ElastixSIPPanelGUI.prototype._setComposingState = function(uri, state) {
    var target = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div[data-uri="' + uri + '"]');
    target.find('div.elx_chat_composing').remove();
    if (state == 'active') {
        var messagediv = $('<div class="elx_chat_composing"></div>');
        messagediv.text(arrLang_panel.elastixwebphone.MSG_CHAT_COMPOSING);
        target.append(messagediv).scrollTop(1e4);
    }
}
ElastixSIPPanelGUI.prototype._addMessage = function(uri, direction, message) {
    var chatdiv = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div[data-uri="' + uri + '"]');

    var send_name;
    if (direction == 'out') {
        send_name = arrLang_panel.elastixwebphone.MSG_CHAT_MYSELF;
    } else {
        send_name = uri;
        if (chatdiv.data('name') != undefined)
            send_name = chatdiv.data('name');
        var liContact = this._panelAS().find("div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li[data-uri=\"" + uri + "\"]");
        if (liContact.length > 0) {
            send_name = liContact.data('name');
        }
    }

    var elem = {
        date: new Date().toLocaleTimeString(),
        from: send_name,
        mesg: message
    };
    this._addMessageElement(chatdiv, elem);

    chatdiv.scrollTop(1e4);

    if (direction != 'out') {
        chatdiv.find('div.elx_chat_composing').remove();

        if (!chatdiv.is(':visible')) {
            chatdiv.addClass('chat-unread');
            this._countUnreadChats();
        }
        this._notifyNewChatMsg(send_name, message);
    }

    this._updateSessionStorage_Chat();
}
ElastixSIPPanelGUI.prototype._addMessageElement = function(chatdiv, elem) {
    var messagediv = this._panelAS().find('div#elx-phonetab-chats > div.chatmessage').clone();
    messagediv.find('div.time').text(elem.date);
    messagediv.find('div.user').text(elem.from);
    if (typeof elem.mesg == 'string')
        messagediv.children('div.body').text(elem.mesg);
    else messagediv.children('div.body').append(elem.mesg);
    messagediv.appendTo(chatdiv).show();

    var log = chatdiv.data('log');
    if (log == undefined) log = [];
    log.push(elem);
    chatdiv.data('log', log);
}
ElastixSIPPanelGUI.prototype._closeChat = function (uri) {
    var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');

    // Buscar si existe el chat activo para el uri indicado
    if (uri == '') return;
    var op = sel.children('option[value="' + uri + '"]');
    if (op.length <= 0) return;

    // Quitar div y option del select
    this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div[data-uri="' + uri + '"]')
        .hide();
    op.addClass('chat-closed').hide();

    // Si sólo queda el elemento de no-chats, mostrarlo y ocultar controles
    var rem = sel.children('option:not(.chat-closed)[value!=""]');
    if (rem.length <= 0) {
        sel.children('option[value=""]').show();
        sel.val('');
    } else {
        // Elegir primer elemento no-vacío
        var nval = rem.first().val();
        sel.val(nval);
    }
    sel.change();

    this._updateSessionStorage_Chat();
}
ElastixSIPPanelGUI.prototype._updateSessionStorage_Chat = function() {
    if (typeof window.sessionStorage == 'undefined') return;
    if (typeof JSON == 'undefined') return;

    var s = {};
    var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');
    this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div').each(function() {
        var uri = $(this).data('uri');
        var log = $(this).data('log');
        if (log == undefined) log = [];
        s[uri] = {log: log, name: $(this).data('name')};

        var opt = sel.children('option[value="'+uri+'"]');
        if (opt != undefined && opt.hasClass('chat-closed')) {
            s[uri].closed = true;
        }
    });
    window.sessionStorage.elxwebphoneChatState = JSON.stringify(s);
}
ElastixSIPPanelGUI.prototype._restoreSessionStorage_Chat = function() {
    if (typeof window.sessionStorage == 'undefined') return;
    if (typeof JSON == 'undefined') return;

    if (window.sessionStorage.elxwebphoneChatState == undefined) return;
    var s = JSON.parse(window.sessionStorage.elxwebphoneChatState);
    var chatdiv;
    for (var uri in s) {
        var sipuri = uri;
        if (/^\w+:/.exec(sipuri) == null) sipuri = 'sip:' + sipuri;
        this._createChat(sipuri, s[uri].name);
        chatdiv = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div[data-uri="' + sipuri + '"]');
        for (var i = 0; i < s[uri].log.length; i++) {
            this._addMessageElement(chatdiv, s[uri].log[i]);
        }
        if (s[uri].closed != undefined && s[uri].closed) {
            this._closeChat(sipuri);
        }
    }
}
ElastixSIPPanelGUI.prototype._countUnreadChats = function () {
    var div_unread = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_group > div.chat-unread');
    var c = div_unread.length;
    var span_unread = this._panelAS().find('div#bar-buttons > a#barnav-chats > span#elxwebphone-chats-unread');
    span_unread.text(c);
    if (c > 0)
        span_unread.show();
    else
        span_unread.hide();
    var sel = this._panelAS().find('div#elx-phonetab-chats > div#elx_chat_select_wrap > select#elx_chat_active');
    sel.children('option').removeClass('chat-unread');
    div_unread.each(function (idx) {
        var uri = $(this).data('uri');
        sel.children('option[value="'+uri+'"]').addClass('chat-unread');
    });
}
ElastixSIPPanelGUI.prototype._notifyNewChatMsg = function(from, message) {
    this._clearNotifyChatMsg();
    if (this._canNotify) {
        var new_message = arrLang_panel.elastixwebphone.MSG_UNREAD_FROM
            + ' ' + from;

        this._notiChat = new Notification(
            arrLang_panel.elastixwebphone.TITLE_NOTI_NEW_MESSAGE + ': ' + from, {
                body: message.slice(0, 80)
            }
        );
        this._notiChat.onclick = function() {
            if (!this.panel.is(':visible')) {
                // HACK esto debería ser rutina oficial del framework
                // Mostrar la barra lateral si estaba oculta
                $('#togglesidebar').click();
            }
            this._panelAS().find('div#bar-buttons > a#barnav-chats')
                .click();
        }.bind(this);

    }
}
ElastixSIPPanelGUI.prototype._clearNotifyChatMsg = function() {
    if (this._notiChat != null) {
        this._notiChat.close();
        this._notiChat = null;
    }
}
ElastixSIPPanelGUI.prototype.subscribeMWI = function() {
    if (this._mwi != null) return;

    var ua = this._getCurrSIPUA();
    var s_options = {
        extraHeaders:   ['Accept: application/simple-message-summary']
    };
    this._mwi = ua.subscribe(this.getLocalContact(), 'message-summary', s_options);
    this._mwi.on('notify', this._notifyMWI.bind(this));
}
ElastixSIPPanelGUI.prototype.unsubscribeMWI = function() {
    if (this._mwi == null) return;

    this._mwi.unsubscribe();
    this._mwi.close();
    this._mwi = null;
}
ElastixSIPPanelGUI.prototype._notifyMWI = function(notification) {
    var headers = {};
    var rx = /^(\d+)\/(\d+)(\s*\((\d+)\/(\d+)\))?$/;
    var mwi = this._panelAS().find('div#presence > div#mwi')

    mwi.children('span').hide();
    mwi.find('span > span.number').hide().text('0');

    notification.request.body
        .trim().split("\r\n").forEach(function(val, idx) {
        var f = val.split(": ", 2);
        var m = rx.exec(f[1]);
        if (m != null) {
            headers[f[0]] = [
                parseInt(m[1]),
                parseInt(m[2]),
                (m[4] == undefined) ? 0 : parseInt(m[4]),
                (m[5] == undefined) ? 0 : parseInt(m[5])
            ];
            if (headers[f[0]][0] > 0) {
                mwi.find('span#' + f[0] + ' > span.number').text(headers[f[0]][0]);
                if (headers[f[0]][0] > 1)
                    mwi.find('span#' + f[0] + ' > span.number').show();
                mwi.children('span#' + f[0]).show();
            }
        } else {
            headers[f[0]] = f[1];
        }
    });

    // Recoger extensión a marcar para voicemail, normalmente *97
    var vmdial = null;
    if (headers['Message-Account'] != undefined) {
        var rx_vm = /sip:(.+?)@/;
        var m = rx_vm.exec(headers['Message-Account']);
        if (m != null) vmdial = m[1];
    }
    mwi.data('vmdial', vmdial);

    if (headers['Messages-Waiting'] == 'yes')
        mwi.show();
    else
        mwi.hide();
}
ElastixSIPPanelGUI.prototype.getLocalContact = function() {
    var ua = this._getCurrSIPUA();
    return 'sip:' + ua.configuration.authorizationUser + '@' + ua.configuration.hostportParams;
}
ElastixSIPPanelGUI.prototype._addPhone2History = function(phone, status) {
    var listhistory = this._panelAS().find('div#elx-phonetab-callhistory');
    var liPhone = listhistory.find('ul#elx_template_call_entry > li').clone();
    var contactname = this._panelAS().find('div#elx-phonetab-contacts > div#elx_im_list_contacts > ul#elx_ul_list_contacts > li[data-extension="'+phone+'"]')
        .data('name');

    liPhone.addClass(status);
    liPhone.find('div.phone > span.dialnumber').text(phone);
    liPhone.find('div.phone > span.calldate').text(new Date().toLocaleTimeString());
    if (contactname != undefined) {
        liPhone.find('div.phone > span.contactname').text(contactname);
    }
    liPhone.data('phone', phone);
    listhistory.children('ul#elx_ul_list_calls').prepend(liPhone);

    if (/^[\d#*]+$/.exec(phone)) {
        var dl = this._panelAS().find('datalist#elxwebphone-autocomplete');
        dl.children('option[value="'+phone+'"]').remove();
        $('<option/>').val(phone).prependTo(dl);
    }
}
ElastixSIPPanelGUI.prototype._changeVolume = function() {
    var val = this._panelAS().find('div#phonebox > div#volumecontrols > div#volumeslider')
        .slider('value');
    if (val < 0) val = 0;
    if (val > 100) val = 100;
    this._panelAS().find('#elx_media_remote').prop('volume', val / 100.0);
}
ElastixSIPPanelGUI.prototype._showMuted = function(m) {
    var sel_icon = 'div#phonebox > div#elxwebphone-dialed-extension-wrap > div#icons > a#volumeicon';
    var sel_button = 'div#phonebox > div#volumecontrols > button#elxwebphone-do-togglemute';
    var sel = sel_icon + ', ' + sel_button;
    if (m) {
        this._panelAS().find(sel).addClass('muted');
        this._panelAS().find(sel_button + ' > i.fa-microphone')
            .removeClass('fa-microphone')
            .addClass('fa-microphone-slash');
    } else {
        this._panelAS().find(sel).removeClass('muted');
        this._panelAS().find(sel_button + ' > i.fa-microphone-slash')
            .removeClass('fa-microphone-slash')
            .addClass('fa-microphone');

    }
}

/**
 * La clase Presentity es una clase que modela el documento XML que contiene la
 * información de presencia RPID. La presencia rica puede estar activa (propiedad
 * open en TRUE) o inactiva. Se puede agregar una nota para describir con más
 * detalle el tipo de actividad en que se encuentra el usuario. Además se soporta
 * una lista de actividades (propiedad activities) cuyo contenido determina si
 * el usuario está disponible, ocupado, ausente, u otra cosa.
 *
 * La clase soporta generar el XML a partir de las propiedades, y además parsear
 * un documento XML y separar sus propiedades. La implementación se ha probado
 * con el documento XML publicado por Jitsi.
 */
function Presentity()
{
    // urn:ietf:params:xml:ns:pidf      http://tools.ietf.org/html/rfc3863
    // urn:ietf:params:xml:ns:pidf:rpid http://tools.ietf.org/html/rfc4480
    this.user = "user";
    this.domain = "example.com";
    this.activities = [];
    this.status_icon = null;
    this.open = true;
    this.note = "Online";

    this.digium_presence_type = null;
    this.digium_presence_subtype = null;
    this.digium_presence_message = null;
}
/** Generación del documento XML a partir de las propiedades */
Presentity.prototype.toXML = function() {
    var xml_presence = $.parseXML(
        '<?xml version="1.0" encoding="UTF-8" standalone="no"?>' +
        '<presence xmlns="urn:ietf:params:xml:ns:pidf" xmlns:dm="urn:ietf:params:xml:ns:pidf:data-model" xmlns:rpid="urn:ietf:params:xml:ns:pidf:rpid"/>');
    var sipuri = 'sip:' + this.user + '@' + this.domain;

    /* A partir de aquí se usan funciones nativas de XMLDocument porque la
     * abstracción de jQuery no permite agregar elementos con namespace
     */
    var xmlpr = xml_presence.getElementsByTagName('presence')[0];
    xmlpr.setAttribute('entity', sipuri);

    var xmlpers = xml_presence.createElementNS("urn:ietf:params:xml:ns:pidf:data-model", "person");
    xmlpers.setAttribute('id', 'p1401');
    var xmlactivities = xml_presence.createElementNS("urn:ietf:params:xml:ns:pidf:rpid", "activities");

    // http://tools.ietf.org/html/rfc4480
    var knownactivities = ['appointment', 'away', 'breakfast', 'busy', 'dinner',
        'holiday', 'in-transit', 'looking-for-work', 'lunch', 'meal', 'meeting',
        'on-the-phone', 'performance', 'permanent-absence', 'playing', 'presentation',
        'shopping', 'sleeping', 'spectator', 'steering', 'travel', 'tv', 'unknown',
        'vacation', 'working', 'worship'];
    for (var i = 0; i < this.activities.length; i++) {
        var xmlactv
        if (-1 != knownactivities.indexOf(this.activities[i])) {
            xmlactv = xml_presence.createElementNS("urn:ietf:params:xml:ns:pidf:rpid", this.activities[i]);
        } else {
            xmlactv = xml_presence.createElementNS("urn:ietf:params:xml:ns:pidf:rpid", 'other');
            xmlactv.appendChild(xml_presence.createTextNode(this.activities[i]));
        }
        xmlactivities.appendChild(xmlactv);
    }
    xmlpers.appendChild(xmlactivities);
    if (this.status_icon != null) {
        var xmlicon = xml_presence.createElementNS("urn:ietf:params:xml:ns:pidf:rpid", "status-icon");
        xmlicon.appendChild(xml_presence.createTextNode(this.status_icon));
        xmlpers.appendChild(xmlicon);
    }
    xmlpr.appendChild(xmlpers);


    var xmltuple = xml_presence.createElement('tuple');
    xmltuple.setAttribute('id', 't1072');

    var xmlstatus = xml_presence.createElement('status');
    var xmlbasic = xml_presence.createElement('basic');
    xmlbasic.appendChild(xml_presence.createTextNode(this.open ? 'open' : 'closed'));
    xmlstatus.appendChild(xmlbasic);
    xmltuple.appendChild(xmlstatus);
    var xmlcontact = xml_presence.createElement('contact');
    xmlcontact.appendChild(xml_presence.createTextNode(sipuri));
    xmltuple.appendChild(xmlcontact);
    var xmlnote = xml_presence.createElement('note');
    xmlnote.appendChild(xml_presence.createTextNode(this.note));
    xmltuple.appendChild(xmlnote);
    xmlpr.appendChild(xmltuple);

    return xml_presence;
}

Presentity.prototype.fromXML_sipuri = function(sipuri) {
    var m = /^(sip:)?(\S+)@(\S+)$/.exec(sipuri);
    this.user = m[2];
    this.domain = m[3];
}

/** Parseo de un XML y extracción de las propiedades */
Presentity.prototype.fromXML = function(xml_presence) {
    var hasnote = false;

    var xmlpr = xml_presence.getElementsByTagName('presence')[0];

    // Blink manda el atributo entity codificado
    var sipuri = decodeURIComponent(xmlpr.getAttribute('entity'));
    this.fromXML_sipuri(sipuri);

    // Kamailio y Asterisk difieren en el namespace para colocar la actividad
    this.activities = [];
    var ns_person = [
        "urn:ietf:params:xml:ns:pidf:rpid",             // Kamailio
        "urn:ietf:params:xml:ns:pidf:rpid:rpid-person"  // Asterisk 11.x
    ];
    for (var i = 0; i < ns_person.length; i++) {
        var xmlactivities = xml_presence.getElementsByTagNameNS(
            ns_person[i],
            "activities");
        if (xmlactivities.length > 0) for (var i = 0; i < xmlactivities[0].childNodes.length; i++) {
            var xmlactv = xmlactivities[0].childNodes[i];
            if (xmlactv.nodeType == xml_presence.ELEMENT_NODE) {
                var m = /^(\S+:)?(\S+)/.exec(xmlactv.nodeName);
                var nodeName = m[2];

                if (nodeName == 'other') {
                    // Asume que el texto es el único contenido
                    if (xmlactv.childNodes.length > 0)
                        this.activities.push(xmlactv.childNodes[0].nodeValue);
                } else {
                    this.activities.push(nodeName);
                }
            }
        }
    }

    this.status_icon = null;
    var xmlicons = xml_presence.getElementsByTagNameNS(
        "urn:ietf:params:xml:ns:pidf:rpid",
        "status-icon");
    if (xmlicons.length > 0) {
        // Asume que el texto es el único contenido
        if (xmlicons[0].childNodes.length > 0)
            this.status_icon = xmlicons[0].childNodes[0].nodeValue;
    }

    // Asterisk pone el tag note aquí
    this.note = "Offline";
    var xmlnote = xml_presence.getElementsByTagName('note');
    if (xmlnote.length > 0) {
        this.note = xmlnote[0].childNodes[0].nodeValue;
        hasnote = true;
    }

    var xmltuple = xml_presence.getElementsByTagName('tuple');
    if (xmltuple.length > 0) {

        // Asterisk manda el nombre del contacto aquí
        var xmlcontact = xmltuple[0].getElementsByTagName('contact');
        if (xmlcontact.length > 0) {
            sipuri = xmlcontact[0].childNodes[0].nodeValue;
            this.fromXML_sipuri(sipuri);
        }

        this.open = false;
        var xmlstatus = xmltuple[0].getElementsByTagName('status');
        if (xmlstatus.length > 0) {
            var xmlbasic = xmlstatus[0].getElementsByTagName('basic');
            if (xmlbasic.length > 0) {
                this.open = ('open' == xmlbasic[0].childNodes[0].nodeValue);
            }
        }

        var xmlnote = xmltuple[0].getElementsByTagName('note');
        if (xmlnote.length > 0) {
            this.note = xmlnote[0].childNodes[0].nodeValue;
            hasnote = true;
        } else if (!hasnote) {
            // Blink no asigna la nota. Se sintetiza una en base a las actividades
            if (this.activities.indexOf('available') != -1) {
                this.note = 'Online';
            } else if (this.activities.indexOf('away') != -1) {
                this.note = 'Away';
            } else if (this.activities.indexOf('busy') != -1) {
                this.note = 'Busy (DND)';
            }
        }
    }

    // Parsear presencia Digium si está disponible
    this.digium_presence_type = null;
    this.digium_presence_subtype = null;
    this.digium_presence_message = null;
    if (xmltuple.length > 1 && xmltuple[1].getAttribute('id') == 'digium-presence') {
        var xmlstatus = xmltuple[1].getElementsByTagName('status');
        if (xmlstatus.length > 0) {
            var xmldigium = xmlstatus[0].getElementsByTagName('digium_presence');
            if (xmldigium.length > 0) {
                // not_set unavailable available away xa chat dnd
                this.digium_presence_type = xmldigium[0].getAttribute('type');
                this.digium_presence_subtype = xmldigium[0].getAttribute('subtype');
                this.digium_presence_message = '';
                if (xmldigium[0].childNodes.length > 0)
                    this.digium_presence_message = xmldigium[0].childNodes[0].nodeValue;

                if (this.digium_presence_type == 'not_set' || this.digium_presence_type == '') {
                    this.digium_presence_type = null;
                    this.digium_presence_subtype = null;
                    this.digium_presence_message = null;
                } else {
                    if (this.activities.indexOf(this.digium_presence_type) == -1)
                        this.activities.push(this.digium_presence_type);
                    if (this.digium_presence_subtype == '')
                        this.digium_presence_subtype = null;
                    if (this.digium_presence_message == '')
                        this.digium_presence_message = null;
                }
            }
        }
    }
}

Presentity.prototype.toString = function() {
    var xml = (new XMLSerializer()).serializeToString(this.toXML());
    xml = xml.replace(/ xmlns=""/g, '');
    return xml;
}

Presentity.prototype.fromString = function(s) {
    return this.fromXML($.parseXML(s));
}

// Elegir el color a mostrar según notas y actividades
Presentity.prototype.suggestStateColor = function() {
    var color = '#8cbe29';
    if (this.open) {
        if (this.activities.length == 1 && this.activities.indexOf('available') != -1) {
            // Estado disponible estilo Blink
            color = '#8cbe29';
        } else if (this.activities.indexOf('unavailable') != -1) {
            color = 'gray';
        } else {
            if (this.activities.length > 0) color = 'orange';
            if (this.activities.indexOf('chat') != -1) color = '#64b5f6';  // <-- estatus Digium
            if (this.activities.indexOf('xa') != -1) color = 'brown';   // <-- estatus Digium
            if (this.activities.indexOf('away') != -1) color = 'yellow';
            if (this.activities.indexOf('busy') != -1) color = 'red';
            if (this.activities.indexOf('dnd') != -1) color = 'red';    // <-- estatus Digium
            if (this.activities.indexOf('on-the-phone') != -1) color = 'red';
        }
    } else {
        color = 'grey';
    }

    return color;
}

// Elegir estado de ringeo según notas y actividades. Específico para Asterisk
Presentity.prototype.suggestRingingState = function() {
    var state = 'idle';
    if (this.activities.indexOf('busy') != -1) {
        state = 'oncall';
        if (this.note == 'Ringing') {
            state = 'ringing';
        }
    }
    return state;
}

function SIPPresence(ua, gui)
{
    this._gui = gui;
    this.ua = ua;
    this.presentity = new Presentity();
    this.presentity.user = ua.configuration.authorizationUser;
    this.presentity.domain = ua.configuration.hostportParams;
    this.presenceETag = null;
    this.presenceTimer = null;
    this.publishRequest = null;
    this.roster = {}; // Subscripciones a lista de contactos
    this.subsWatch = null;  // Subscripción a presence.winfo

    this.subscribeAll();
}
SIPPresence.prototype.getLocalContact = function() {
    return 'sip:' + this.ua.configuration.authorizationUser + '@' + this.ua.configuration.hostportParams;
}
/**
 *  Ejecutar la subscripción al evento presence.winfo . Este evento informa de
 * quién desea observar al usuario local, y la política seguida aquí es la
 * de autorizar de inmediato la escucha. */
SIPPresence.prototype.subscribeWatcher = function() {
    /*
    <?xml version="1.0"?>
    <watcherinfo xmlns="urn:ietf:params:xml:ns:watcherinfo" version="1" state="full">
      <watcher-list resource="sip:avillacis@pbx.villacis.com" package="presence"/>
    </watcherinfo>

    <?xml version="1.0"?>
    <watcherinfo xmlns="urn:ietf:params:xml:ns:watcherinfo" version="2" state="partial">
      <watcher-list resource="sip:avillacis@pbx.villacis.com" package="presence">
        <watcher id="87590e851228150e5980f7ca45a1b9ce@0:0:0:0:0:0:0:0" event="subscribe" status="pending">sip:gmacas@pbx.villacis.com</watcher>
      </watcher-list>
    </watcherinfo>
    */
    this.subsWatch = this.ua.subscribe(this.getLocalContact(), 'presence.winfo', {
        extraHeaders:   ['Accept: application/watcherinfo+xml']
    });
    this.subsWatch.on('notify', function(notification) {
        var xmlwatch = $.parseXML(notification.request.body);

        $(xmlwatch).find('watcherinfo > watcher-list[package=presence] watcher[event=subscribe][status=pending]')
            .each(function(idx, value) {
            //console.log("Aprobando ingreso a roster de contacto: " + $(value).text());
            this.subscribeToRoster($(value).text().replace(/^sip:/, ''));
        }.bind(this));
    }.bind(this));
    this.subsWatch.on('failed', function (response, cause) {
        if (response.status_code == 489) {
            // Asterisk no soporta SUBSCRIBE Event: presence.winfo
            console.debug(response.status_code + ' ' + ((cause == null) ? '(null)' : cause));
        } else {
            this._gui.displayStatusMessage(
                'Failed to SUBSCRIBE presence.winfo: ' + response.status_code + ' ' + cause);
        }
        this.subsWatch.close();
        this.subsWatch = null;
    }.bind(this));
}
SIPPresence.prototype.unsubscribeWatcher = function() {
    if (null == this.subsWatch) return;
    this.subsWatch.unsubscribe();
    this.subsWatch.close();
    this.subsWatch = null;
}
/**
 * Método para iniciar la publicación de la presencia del usuario local.
 * Para mitigar la situación de que no es posible cerrar la presencia de
 * forma síncrona, se establece la expiración de la presencia a 90 segundos,
 * y se actualiza la presencia cada 60 segundos con un timer.
 */
SIPPresence.prototype.publishPresence = function () {

    if (this.presenceETag == null) {
        // Verificar si se tiene un PUBLISH previo en el servidor
        $.get('index.php', {
            menu: '_elastixpanel',
            elastixpanel: 'elastixwebphone',
            action: 'getPublishState'
        }, function(data) {
            if (data.message != "") {
                this.presenceETag = (data.message.ETag != "") ? data.message.ETag : null; // puede ser null
                this.presentity.note = data.message.note;
                this.presentity.activities = data.message.activities;
            }
            this._publishPresence();
        }.bind(this));
    } else {
        this._publishPresence();
    }
}
SIPPresence.prototype._publishPresence = function() {
    if (this.publishRequest == null) {
        var extrahdr = [
            'Event: presence',
            'Content-Type: application/pidf+xml',
            'Contact: ' + this.ua.contact.toString()
        ];
        this.publishRequest = this.ua.request('PUBLISH', this.getLocalContact(), {
            body: this.presentity.toString(),
            extraHeaders: extrahdr
        });
        this.publishRequest.request.setHeader('Expires', '90');
        if (this.presenceETag != null) {
            this.publishRequest.request.setHeader('SIP-If-Match', this.presenceETag);
        }
        this.publishRequest.on('accepted', function (response, cause) {
            if (response.getHeader('Expires') != "0") {
                this.presenceETag = response.getHeader('Sip-Etag');
                // mandar this.presenceETag al servidor para recuperar
                // SIP-If-Match luego de recargar la página
                $.post('index.php', {
                    menu: '_elastixpanel',
                    elastixpanel: 'elastixwebphone',
                    action: 'setPublishState',
                    ETag: this.presenceETag,
                    note: this.presentity.note,
                    activities: this.presentity.activities
                }, function(data) {});

                this.publishRequest.request.setHeader('SIP-If-Match', this.presenceETag);

                // Elegir el color a mostrar según notas y actividades
                this._gui.updateMyStatus(this.presentity.suggestStateColor());
            } else {
                this.publishRequest = null;
                this.presenceETag = null;
                $.post('index.php', {
                    menu: '_elastixpanel',
                    elastixpanel: 'elastixwebphone',
                    action: 'setPublishState',
                    ETag: ''
                }, function(data) {});
                this._gui.updateMyStatus('gray');
            }
        }.bind(this));
        this.publishRequest.on('rejected', function (response, cause) {
            if (response.status_code == 412) {
                /* 412 Conditional request failed */
                if (this.presenceETag != null) {
                    /* Si ocurre este error, entonces ha ocurrido un error
                     * de sincronización, y el ETag almacenado es inválido.
                     */
                    this.presenceETag = null;
                    delete this.publishRequest.request.headers['Sip-If-Match'];
                    this.publishRequest.send();
                    return;
                }
            }

            // Ha ocurrido otro error que no se sabe manejar
            if (response.status_code == 489) {
                // Asterisk no soporta PUBLISH Event: presence
                console.debug(response.status_code + ' ' + cause);
                if (null != this.presenceTimer) {
                    window.clearInterval(this.presenceTimer);
                    this.presenceTimer = null;
                }
                this.publishRequest = null;
            } else {
                this._gui.displayStatusMessage(
                    'Failed to PUBLISH presence: ' + response.status_code + ' ' + cause);
            }
        }.bind(this));
    } else {
        this.publishRequest.request.setHeader('Expires', '90');
        this.publishRequest.request.body = this.presentity.toString();
        this.publishRequest.send();
    }

    if (null == this.presenceTimer)
        this.presenceTimer = window.setInterval(this.publishPresence.bind(this), 60 * 1000);
}

/**
 * Método para retirar la presencia de la cuenta local, efectivamente indicado
 * que se retira la sesión de chat.
 */
SIPPresence.prototype.withdrawPresence = function () {

    if (null != this.presenceTimer) {
        window.clearInterval(this.presenceTimer);
        this.presenceTimer = null;
    }

    if (null == this.publishRequest) return;

    this.publishRequest.request.setHeader('Expires', '0');
    this.publishRequest.send();
}

SIPPresence.prototype.setPresenceStatus = function (note, activities) {
    this.presentity.note = note;
    this.presentity.activities = activities;
    if (this.publishRequest != null) {
        this.publishPresence();
    } else {
        this._publishDigiumPresence(note, activities[0],
            (activities.length > 1) ? activities[1] : '');
    }
}
SIPPresence.prototype.subscribeAll = function() {
    var uris = this._gui.getContactURIs();
    var i;
    for (i = 0; i < uris.length; i++) this.subscribeToRoster(uris[i]);
}
SIPPresence.prototype.unsubscribeAll = function() {
    for (var contact in this.roster) this.unsubscribeFromRoster(contact);
}
/**
 * Método para subscribirse a la presencia de un contacto, y recibir estado
 * de presencia. Hasta ahora funciona con Jitsi.
 */
SIPPresence.prototype.subscribeToRoster = function(contact) {
    if (this.roster[contact] != null) return;

    var subscription = this.ua.subscribe(contact, 'presence', {
        extraHeaders:   ['Accept: application/pidf+xml']
    });
    subscription.on('notify', this._notifyPresence.bind(this));
    this.roster[contact] = subscription;
}
/**
 * Método para quitar la subscripción del contacto.
 */
SIPPresence.prototype.unsubscribeFromRoster = function(contact) {
    if (this.roster[contact] == null) return;
    this.roster[contact].unsubscribe();
    this.roster[contact].close();
    delete this.roster[contact];

    this._updateContactStatus(contact, 'grey', '(unknown)');
}
SIPPresence.prototype._notifyPresence = function (notification) {
    var pres = new Presentity();
    pres.open = false;
    pres.note = 'Offline';
    pres.user = notification.request.from.uri.user;
    pres.domain = notification.request.from.uri.host;
    if ('' != notification.request.body) {
        pres.fromString(notification.request.body);
    }
    var message = pres.note;
    if (pres.digium_presence_type != null && pres.digium_presence_type != 'available') {
        var typemap = {
            'unavailable':  'Unavailable',
            'away':         'Away',
            'xa':           'Extended Away',
            'chat':         'Chat Preferred',
            'dnd':          'Do Not Disturb'
        };
        if (message == 'Ready') message = ''; else message += ': ';
        message += typemap[pres.digium_presence_type];
    }
    if (pres.digium_presence_subtype != null) {
        if (message != '') message += ' ';
        message += '(' + pres.digium_presence_subtype + ')'
    }
    if (pres.digium_presence_message != null) {
        if (message != '') message += ' - ';
        message += pres.digium_presence_message;
    }

    var contact = 'sip:' + pres.user + "@" + pres.domain;

    this._updateContactStatus(contact, pres.suggestStateColor(), message);
    if (contact == this.getLocalContact() && pres.digium_presence_type != null) {
        var activities = [pres.digium_presence_type];
        if (pres.digium_presence_subtype != null)
            activities.push(pres.digium_presence_subtype);
        this.presentity.activities = activities;
        if (pres.digium_presence_message != null)
            this.presentity.note = pres.digium_presence_message;
        this._gui.updateDigiumPresence(
            pres.digium_presence_type,
            pres.digium_presence_subtype,
            pres.digium_presence_message);
    }

    // Estado de ringeo de Asterisk
    this._gui.updateContactBLF(contact, pres.suggestRingingState());
}
SIPPresence.prototype._updateContactStatus = function(contact, newColor, newNote) {
    this._gui.updateContactStatus(contact, newColor, newNote);
}
SIPPresence.prototype._publishDigiumPresence = function(note, state, substate) {
    this.ua.message('CustomPresence', note, {
        extraHeaders: [
            'X-ElastixPresence-Type: ' + state,
            'X-ElastixPresence-Subtype: ' + substate
        ]
    });
}

/*
function SIPBLF(ua, gui)
{
    this._gui = gui;
    this.ua = ua;
    this.roster = {};   // Subscripciones a BLF de contactos

    this.subscribeAll();
}
SIPBLF.prototype.subscribeAll = function() {
    var uris = this._gui.getContactURIs();
    var i;
    for (i = 0; i < uris.length; i++) this.subscribeToRoster(uris[i]);
}
SIPBLF.prototype.unsubscribeAll = function() {
    for (var contact in this.roster) this.unsubscribeFromRoster(contact);
}
SIPBLF.prototype.subscribeToRoster = function(contact) {
    if (this.roster[contact] != null) return;

    var s_options = {
        extraHeaders:   ['Accept: application/dialog-info+xml']
    };
    this.roster[contact] = this.ua.subscribe(contact, 'dialog', s_options);
    this.roster[contact].on('notify', this._notifyBLF.bind(this));
}
SIPBLF.prototype.unsubscribeFromRoster = function(contact) {
    if (this.roster[contact] == null) return;

    this.roster[contact].unsubscribe();
    this.roster[contact].close();
    delete this.roster[contact];

    this._gui.updateContactBLF(contact, 'idle');
}
SIPBLF.prototype._notifyBLF = function(notification) {
    var xml_blf = $.parseXML(notification.request.body);
    var xml_dialog_info = xml_blf.getElementsByTagName('dialog-info')[0];
    var sipuri = decodeURIComponent(xml_dialog_info.getAttribute('entity'));
    var m = /^(sip:)?(\S+@\S+)$/.exec(sipuri);
    var contact = m[2];

    var xmlstate = xml_blf.getElementsByTagName('state');
    var nstatus = 'terminated';
    if (xmlstate.length > 0) {
        // Asume que el texto es el único contenido
        if (xmlstate[0].childNodes.length > 0)
            nstatus = xmlstate[0].childNodes[0].nodeValue;
    }
    switch (nstatus) {
    case 'trying':
    case 'proceeding':
    case 'early':
        this._gui.updateContactBLF(contact, 'ringing');
        break;
    case 'confirmed':
        this._gui.updateContactBLF(contact, 'oncall');
        break;
    default:
        this._gui.updateContactBLF(contact, 'idle');
        break;
    }
}
*/

function PlayDTMF()
{
    this._freq = {
        '1': [697,1209],'2': [697,1336],'3': [697,1477],'A': [697,1633],
        '4': [770,1209],'5': [770,1336],'6': [770,1477],'B': [770,1633],
        '7': [852,1209],'8': [852,1336],'9': [852,1477],'C': [852,1633],
        '*': [941,1209],'0': [941,1336],'#': [941,1477],'D': [941,1633]
    };
    this._ctx = null;
    this.duration = 100;
    this._ringTimer = null;
    this._ringOsc = null;
    var cls = (window.AudioContext || window.webkitAudioContext);
    if (cls != undefined) {
        this._ctx = new cls();
    }
}
PlayDTMF.prototype.play = function(c) {
    if (this._ctx == null) return;
    if (typeof this._freq[c] == 'undefined') return;

    var o = this._freq[c].map(function(f) {
        var osc = this._ctx.createOscillator();
        osc.frequency.value = f;
        osc.connect(this._ctx.destination);
        osc.start();
        return osc;
    }, this);
    setTimeout(function() {
        o.forEach(function(osc) {
            osc.stop();
            osc.disconnect(this._ctx.destination)
        }, this);
    }.bind(this), this.duration);
}
PlayDTMF.prototype.ring = function(toggle) {
    if (this._ctx == null) return;
    if (toggle) {
        // Iniciar timbrado
        if (this._ringTimer != null) return;
        this._ringTimer = setTimeout(this._ringBeep.bind(this), 0);
    } else {
        // Detener timbrado
        if (this._ringTimer == null) return;
        clearTimeout(this._ringTimer);
        this._ringTimer = null;
        if (this._ringOsc != null) {
            this._ringOsc.stop();
            this._ringOsc.disconnect(this._ctx.destination);
            this._ringOsc = null;
        }
    }
}
PlayDTMF.prototype._ringBeep = function() {
    this._ringOsc = this._ctx.createOscillator();
    this._ringOsc.frequency.value = 440;
    this._ringOsc.connect(this._ctx.destination);
    this._ringOsc.start();
    this._ringTimer = setTimeout(this._ringSilence.bind(this), 1500);
}
PlayDTMF.prototype._ringSilence = function() {
    if (this._ringOsc != null) {
        this._ringOsc.stop();
        this._ringOsc.disconnect(this._ctx.destination);
        this._ringOsc = null;
    }
    this._ringTimer = setTimeout(this._ringBeep.bind(this), 3500);
}
